package com.kob.backend.consumer.utils;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.ArrayList;
import java.util.List;

/**
 * @author zfp
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
public class Player{
    // 玩家id
    private Integer id;

    private Integer botId; // -1表示用户对局，其他表示bot对局

    private String botCode; // bot执行的代码

    // 玩家的起始坐标(x,y)
    private Integer sx;
    private Integer sy;
    // 所有历史指令
    private List<Integer> steps;



    private boolean check_tail_increasing(int steps) {
        if (steps <= 10) {
            return true;
        }
        if (steps % 3 == 1) {
            return true;
        }
        return false;
    }

    public List<Cell> getCells() {
        List<Cell> res = new ArrayList<>();

        int []dx = {-1,0,1,0}, dy = {0,1,0,-1};
        int x = sx, y = sy;
        int step = 0;
        res.add(new Cell(x,y));
        for (int d : this.steps) {
            x += dx[d];
            y += dy[d];
            res.add(new Cell(x,y));
            step++;
            if (!check_tail_increasing(step)) {
                res.remove(0);
            }
        }
        return res;
    }

    public String getStepsString() {
        StringBuilder res = new StringBuilder();
        for (int i : this.steps) {
            res.append(i);
        }
        return res.toString();
    }


}
