package com.kob.backend.service.impl.ranklist;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.kob.backend.mapper.UserMapper;
import com.kob.backend.pojo.User;
import com.kob.backend.service.ranklist.GetRankListService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class GetRankListServiceImpl implements GetRankListService {
    @Autowired
    private UserMapper userMapper;
    @Override
    public JSONObject getList(Integer page) {
        JSONObject resp = new JSONObject();
        IPage<User> userIPage = new Page<>(page,8); // 每页展示8个
        QueryWrapper<User> queryWrapper = new QueryWrapper<>();
        queryWrapper.orderByDesc("rating"); // 分值从高到低排序
        List<User> users = userMapper.selectPage(userIPage,queryWrapper).getRecords();// 返回满足条件的users

        for (User user: users) user.setPassword(""); // 清空用户的密码

        resp.put("users",users);
        resp.put("users_count",userMapper.selectCount(null));

        return resp;
    }
}
