package com.kob.backend.service.impl.record;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.kob.backend.mapper.RecordMapper;
import com.kob.backend.mapper.UserMapper;
import com.kob.backend.pojo.Record;
import com.kob.backend.pojo.User;
import com.kob.backend.service.record.GetRecordListService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.LinkedList;
import java.util.List;

@Service
public class GetRecordListServiceImpl implements GetRecordListService {
    @Autowired
    private RecordMapper recordMapper;

    @Autowired
    private UserMapper userMapper;

    @Override
    public JSONObject getList(Integer page) {
        IPage<Record> recordIPage = new Page<>(page,8); // page为页号，每页6条记录
        QueryWrapper<Record> queryWrapper = new QueryWrapper<>();
        queryWrapper.orderByDesc("id"); // 按id降序排列

        // 选出当前页展现的对局记录
        List<Record> records = recordMapper.selectPage(recordIPage,queryWrapper).getRecords();

        // 以json格式返回所有对战记录
        JSONObject resp = new JSONObject(); // 返回的response

        List<JSONObject> items = new LinkedList<>();
        for (Record r : records) {
            User userA = userMapper.selectById(r.getAId());
            User userB = userMapper.selectById(r.getBId());

            JSONObject item = new JSONObject();
            item.put("a_username",userA.getUsername());
            item.put("a_photo",userA.getPhoto());
            item.put("b_username",userB.getUsername());
            item.put("b_photo",userB.getPhoto());
            item.put("record",r);

            String result = "平局";
            if ("A".equals(r.getLoser())) result = userA.getUsername() + "胜";
            else if ("B".equals(r.getLoser())) result = userB.getUsername() + "胜";
            item.put("result",result); // 记录对战结果

            items.add(item);
        }

        resp.put("records",items);
        resp.put("records_count",recordMapper.selectCount(null));// 对战记录总数
        return resp;
    }
}
