package com.kob.backend.service.impl.user.account;



import com.kob.backend.pojo.User;
import com.kob.backend.service.impl.utils.UserDetailsImpl;
import com.kob.backend.service.user.account.LoginService;
import com.kob.backend.utils.JwtUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.authentication.AuthenticationManager;
import org.springframework.security.authentication.UsernamePasswordAuthenticationToken;
import org.springframework.security.core.Authentication;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.Map;

/**
 * @author zfp
 */
@Service
public class LoginServiceImpl implements LoginService {

    @Autowired
    private AuthenticationManager authenticationManager;

    @Override
    public Map<String, String> getToken(String username, String password) {
        // 使用下面代码将用户名和密码(密文)封装成一个类
        UsernamePasswordAuthenticationToken authenticationToken = new UsernamePasswordAuthenticationToken(username,password);
        // 登陆验证，登陆失败会自动处理(抛出异常)
        Authentication authenticate = authenticationManager.authenticate(authenticationToken);
        // 获取登陆的用户
        UserDetailsImpl loginUser = (UserDetailsImpl) authenticate.getPrincipal();

        //
        User user = loginUser.getUser();

        // 利用用户id这个信息创建一个token
        String jwt = JwtUtil.createJWT(user.getId().toString());

        Map<String,String> res = new HashMap<>();

        res.put("error_msg","success");
        res.put("token",jwt);
        return res;
    }
}
