package com.kob.botRunningSystem.Service.impl.utils;

import java.util.LinkedList;
import java.util.Queue;
import java.util.concurrent.locks.Condition;
import java.util.concurrent.locks.ReentrantLock;

public class BotPool extends Thread{
    private final ReentrantLock lock = new ReentrantLock(); // 加锁
    private final Condition condition = lock.newCondition(); // 条件变量
    private final Queue<Bot> bots = new LinkedList<>(); // 所有bots


    public void addBot(Integer userId,String botCode,String input) {
        lock.lock();
        try {
            bots.add(new Bot(userId,botCode,input)); // 添加一个bot
            condition.signalAll(); // 唤醒其他线程
        }finally {
            lock.unlock();
        }
    }


    private void consume(Bot bot) {
        Consumer consumer = new Consumer();
        consumer.setTimeout(2000,bot);
    }
    @Override
    public void run() {
        while (true) {
            lock.lock();
            if (bots.isEmpty()) {
                try {
                    condition.await();
                } catch (InterruptedException e) {
                    e.printStackTrace();
                    lock.unlock();
                    break;
                }
            } else {
                Bot bot = bots.remove(); // 取出队头
                lock.unlock(); // 先解锁
                consume(bot); // 执行bot的代码(可能比较耗时)
            }
        }
    }
}
