package com.kob.botRunningSystem.Service.impl.utils;

import org.joor.Reflect;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import org.springframework.web.client.RestTemplate;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.UUID;
import java.util.function.Supplier;


@Component
public class Consumer extends Thread{

    private Bot bot;

    private static RestTemplate restTemplate;

    private static final String receiveBotMoveUrl = "http://127.0.0.1:4000/pk/receive/bot/move/";

    @Autowired
    private void setRestTemplate(RestTemplate restTemplate) {
        Consumer.restTemplate = restTemplate;
    }

    public void setTimeout(long timeout,Bot bot) {
        this.bot = bot;
        this.start();
        try {
            this.join(timeout); // 最多等待timeout秒
        } catch (InterruptedException e) {
            e.printStackTrace();
        } finally {
            this.interrupt(); // 终止当前进程
        }
    }

    private String addUid(String code,String uid) { // 在Code的bot类名后添加uid
        int k = code.indexOf(" implements java.util.function.Supplier<Integer>");
        return code.substring(0,k) + uid + code.substring(k);

    }


    @Override
    public void run() {

        UUID uuid = UUID.randomUUID();
        String uid = uuid.toString().substring(0,8); // 获取8位随机字符串

        Supplier<Integer> botInterface = Reflect.compile(
                "com.kob.botRunningSystem.utils.Bot" + uid,
                addUid(bot.getBotCode(),uid)).create().get();
        File file = new File("input.txt");
        try (PrintWriter fout = new PrintWriter(file)){
            fout.println(bot.getInput());
            fout.flush();
        } catch (FileNotFoundException e) {
            throw new RuntimeException(e);
        }


        Integer direction = botInterface.get();
        System.out.println("move-direction: " + bot.getUserId() + " " + direction);

        MultiValueMap<String,String> data = new LinkedMultiValueMap<>();
        data.add("user_id",bot.getUserId().toString());
        data.add("direction",direction.toString());

        restTemplate.postForObject(receiveBotMoveUrl,data,String.class);
    }
}
